/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	idt.h
	Sets up and handles the Interrupt Descriptor Table.

******************************************************************************/

#ifndef SORTIX_IDT_H
#define SORTIX_IDT_H

class IDT
{
	// Defines an IDT entry
	struct IDTEntry
	{
		uint16_t BaseLow;
		uint16_t Sel; // Our kernel segment goes here.
		uint8_t Always0; //This will ALWAYS be set to 0.
		uint8_t Flags;
		uint16_t BaseHigh;
	} SORTIX_PACKED Entries[256];

	struct IDTPointer
	{
		uint16_t Limit;
		void* Base;
	} SORTIX_PACKED Pointer;
	
public:
	void Init();
	void SetGate(size_t Num, void* BaseP, uint16_t Sel, uint16_t Flags);

};

#endif

