/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	iprintable.h
	A common interface shared by all devices that can be printed text to.

******************************************************************************/

#ifndef SORTIX_IPRINTABLE_H
#define SORTIX_IPRINTABLE_H

namespace Sortix
{
	class IPrintable
	{
	public:
		void PrintFV(const char* Format, const void* Parameters);
		inline void PrintF(const char* Format, ...) { PrintFV(Format, (void*) (&Format + 1)); }

	public:
		virtual void Print(const char* Message) = 0;

	};
}

#endif

