/******************************************************************************

	COPYRIGHT(C) JONAS 'SORTIE' TERMANSEN 2011.

	This file is part of Sortix.

	Sortix is free software: you can redistribute it and/or modify it under the
	terms of the GNU General Public License as published by the Free Software
	Foundation, either version 3 of the License, or (at your option) any later
	version.

	Sortix is distributed in the hope that it will be useful, but WITHOUT ANY
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
	details.

	You should have received a copy of the GNU General Public License along
	with Sortix. If not, see <http://www.gnu.org/licenses/>.

	kernel.h
	This is where our kernel begins.

******************************************************************************/

#ifndef SORTIX_KERNEL_H
#define SORTIX_KERNEL_H

#ifdef SORTIX_KERNELOUTPUT_H
extern KernelOutput* GOut;
#endif

#ifdef SORTIX_PAGEALLOCATOR_H
extern PageAllocator* GPageAllocator;
#endif

#ifdef SORTIX_PAGING_H
extern Paging* GPaging;
#endif

#ifdef SORTIX_GDT_H
extern GDT* GGDT;
#endif

#ifdef SORTIX_IDT_H
extern IDT* GIDT;
#endif

#ifdef SORTIX_ISR_H
extern ISR* GISR;
#endif

#ifdef SORTIX_IRQ_H
extern IRQ* GIRQ;
#endif

#ifdef SORTIX_PIT_H
extern PIT* GPIT;
#endif

#ifdef SORTIX_TIMER_H
extern Timer* GTimer;
#endif

void HackSleep(size_t Miliseconds);

#endif

